declare('soundalertsuite', {})
soundalertsuite.event = {}
soundalertsuite.init = {}
soundalertsuite.events_index = {}
soundalertsuite.version = '1.0.1'

--## Choco ##--

soundalertsuite.ui, soundalertsuite.vars = dofile('ui.lua')

function soundalertsuite.init:PLAYER_ENTERED_GAME(event, data)
	--Register events of enabled items
	for id,v in pairs(soundalertsuite.vars.alerts) do
		if v.enable then
			for _,event_name in ipairs(v.events) do
				if not soundalertsuite.events_index[event_name] then
					RegisterEvent(soundalertsuite, event_name)
					soundalertsuite.events_index[event_name] = {}
				end
				
				table.insert(soundalertsuite.events_index[event_name], id)
			end
		end
	end
end

function soundalertsuite:OnEvent(event, ...)
	local events = soundalertsuite.vars.alerts
	for i,id in ipairs(soundalertsuite.events_index[event]) do
		if events[id] and events[id].enable and ( not(events[id].func) or soundalertsuite[events[id].func](event, ...) ) then
			gksound.GKPlaySound(soundalertsuite.vars.sound_name[events[id].sound], events[id].vol or soundalertsuite.vars.vol_master)
		end
	end
end

function soundalertsuite.isChatAlert(event, data) return data.channelid==tonumber(soundalertsuite.vars.alerts[1].data) and data.name~=GetPlayerName() end
function soundalertsuite.isBuddyEntered(event, data) return data.msg:find("Your buddy .+ logged on%.") end
function soundalertsuite.isBuddyLeft(event, data) return data.msg:find("Your buddy .+ logged off%.") end
function soundalertsuite.isBuddyRequest(event, data) return data.msg:find(".+ requests permission to become your buddy%.") or data.msg:find(".+ is now your buddy%.") end
function soundalertsuite.isReceivedCredits(event, data) return data.msg:find(".+ sent you %d+ credits%.") end
function soundalertsuite.isScoredKill(event, ...)
	local victim, killer, weaponid = ...
	local isNPC = GetPlayerName(victim):match("^*")
	return killer==GetCharacterID() and victim~=GetCharacterID() and (soundalertsuite.vars.alerts[12].option_enable or not isNPC)
end
function soundalertsuite.isGroupAlert(event, data) return true end --TODO

function soundalertsuite.test(id)
	local events = soundalertsuite.vars.alerts
	if events[id] then gksound.GKPlaySound(vars.sound_name[events[id].sound], events[id].vol or soundalertsuite.var.vol_master) end
end

RegisterUserCommand("SAS", function() soundalertsuite.ui:Show() end)
RegisterUserCommand("soundalertsuite", function() soundalertsuite.ui:Show() end)
RegisterEvent(soundalertsuite.init, "PLAYER_ENTERED_GAME")
